module ListUtil where

-- stolen verbatim from Koen Claessen (on Haskell mailing list 2002-06-10)
-- except for the base case of "permutations"
selections []     = []
selections (x:xs) = (x,xs) : [ (y,x:ys) | (y,ys) <- selections xs ]

permutations :: [a] -> [[a]]
permutations [] = [[]]
permutations xs =
  [ y : zs
  | (y,ys) <- selections xs
  , zs     <- permutations ys
  ]
