module ConcurrentUtil where

import Control.Concurrent.MVar

putMVarF :: MVar a -> a -> IO ()
putMVarF var val = val `seq` putMVar var val

putMVarF2 :: MVar (a, b) -> (a, b) -> IO ()
putMVarF2 var val@(x, y) = y `seq` putMVar var val

swapMVarF_ :: MVar a -> a -> IO ()
swapMVarF_ var val =
    do val `seq` return ()
       _ <- swapMVar var val
       return ()

swapMVarF2_ :: MVar (a, b) -> (a, b) -> IO ()
swapMVarF2_ var val@(x, y) =
    do y `seq` return ()
       _ <- swapMVar var val
       return ()

