module RandomUtils where

import Random

random_list_elt :: [elt_t] -> IO elt_t
random_list_elt xs =
    do index <- getStdRandom (randomR (0, length xs - 1))
       return (xs !! index)

random_list_perm :: [elt_t] -> IO [elt_t]
random_list_perm [] = return []
random_list_perm xs =
    do index <- getStdRandom (randomR (0, length xs - 1))
       let (xs_left, x : xs_right) = splitAt index xs
       rest <- random_list_perm (xs_left ++ xs_right)
       return (x : rest)
