module SearchState where

import State
import LegalMoves
import Data.Maybe
import RobberTracking

data SearchState = SearchState
    { ss_epoch :: Epoch,
      ss_cop_states :: [PlayerState],
      ss_robber_state :: PlayerState,
      ss_fake_robber_states :: Maybe [PlayerState],
      ss_impossible_list :: ImpossibleList
    } deriving (Show)
